<?php
// If this file is called directly, abort.
if ( ! defined( 'ABSPATH' ) ) {
    die();
}
/**
 * The Affiliate Links Shortcode Class.
 */
class Affiliate_Links_Shortcode {

    public function __construct() {

        add_shortcode('af_link', array($this, 'shortcode'));

    }

    public function shortcode( $atts, $content = null ) {

        $a = shortcode_atts(
            array(
                'href'   => false,
                'rel'    => false,
                'target' => false,
                'title'  => false,
                'class'  => false,
            ),
            $atts, 'af_link'
        );

        if( $a['href'] ) {
            $href = ' href="' . esc_url( $a['href'] ) . '"';
        } else {
            $href = ' href="#"';
        }

        if( $a['rel'] ) {
            $rel = ' rel="nofollow"';
        } else {
            $rel = '';
        }

        if( $a['target'] ) {
            $target = ' target="_blank"';
        } else {
            $target = '';
        }

        if( $a['title'] ) {
            $title = ' title="' . esc_attr( $a['title'] ) . '"';
        } else {
            $title = '';
        }

        if( $a['class'] ) {
            $class = ' class="' . esc_attr( $a['class'] ) . '"';
        } else {
            $class = '';
        }

        $link_attrs = $href . $rel . $target . $title . $class;

		ob_start();
		?>
		  <a<?php echo $link_attrs ?>><?php echo $content ?></a>
		<?php

		return ob_get_clean();

    }

}

$Affiliate_Links_Shortcode = new Affiliate_Links_Shortcode();